/*
 * Copyright (C) 2010 SENJU Jiro
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <sys/stat.h>
#include <sys/types.h>
#include <assert.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#ifndef PhBufferSize
#define PhBufferSize 16
#endif

int main(int argc, char *argv[])
{
	struct {
		int fd;
		char buffer[PhBufferSize];
	} a[2];
	ssize_t ssz;
	char *p;

	a[0].fd = open(argv[1], O_WRONLY | O_CREAT | O_TRUNC, 0644);
	assert(a[0].fd >= 0);
	a[1].fd = open(argv[1], O_RDONLY);
	assert(a[1].fd >= 0);

	memset(a[0].buffer, 'a', PhBufferSize);
	ssz = write(a[0].fd, a[0].buffer, PhBufferSize);
	assert(ssz == PhBufferSize);
	ssz = read(a[1].fd, a[1].buffer, PhBufferSize);
	/* assert(ssz == PhBufferSize); */
	p = "equivalent";
	if (memcmp(a[0].buffer, a[1].buffer, PhBufferSize))
		p = "different";
	printf("PhBufferSize %d, %zd bytes read, %s\n", PhBufferSize, ssz, p);

	return 0;
}
